local M = {}

local helper = require('scenario/scenariohelper')
local logTag = 'fcv_race'

local finalWaypointName = 'checkpoint1'
local finalTriggerName = 'trigger_finish1'
local playerInstance = 'scenario_player0'
local aiInstance1 = 'scenario_opponent1'
local aiInstance2 = 'scenario_opponent2'
local aiInstance3 = 'scenario_opponent3'

local running = false
local playerWon = false
local aiFinished = false
local noOfLaps = 3
local lapsCompleted = {}

local function reset()
  lapsCompleted['scenario_player0'] = 0
  lapsCompleted['scenario_opponent1'] = 0
  lapsCompleted['scenario_opponent2'] = 0
  lapsCompleted['scenario_opponent3'] = 0

  running = false
  playerWon = false
  aiFinished = false
end





local function onCountdownStarted()
  reset()

  local aiData = jsonReadFile('levels/west_coast_usa/scenarios/fcv_race_opponent1.track.json')
  scenetree.findObject(aiInstance1):queueLuaCommand("ai.startFollowing("..serialize(aiData.recording)..")")

  local aiData = jsonReadFile('levels/west_coast_usa/scenarios/fcv_race_opponent2.track.json')
  scenetree.findObject(aiInstance2):queueLuaCommand("ai.startFollowing("..serialize(aiData.recording)..")")

  local aiData = jsonReadFile('levels/west_coast_usa/scenarios/fcv_race_opponent3.track.json')
  scenetree.findObject(aiInstance3):queueLuaCommand("ai.startFollowing("..serialize(aiData.recording)..")")
end



M.onRaceStart = onRaceStart
M.onCountdownStarted = onCountdownStarted
M.onRaceWaypointReached = onRaceWaypointReached
M.onRaceResult = onRaceResult
M.onVehicleStoppedMoving = onVehicleStoppedMoving
return M